Index: /trunk/sources/HeuristicLab.Data.Views/3.3/HeuristicLab.Data.Views-3.3.csproj
===================================================================
--- /trunk/sources/HeuristicLab.Data.Views/3.3/HeuristicLab.Data.Views-3.3.csproj	(revision 9713)
+++ /trunk/sources/HeuristicLab.Data.Views/3.3/HeuristicLab.Data.Views-3.3.csproj	(revision 9714)
@@ -133,4 +133,22 @@
       <DependentUpon>IntRangeView.cs</DependentUpon>
     </Compile>
+    <Compile Include="Path Views\DirectoryValueView.cs">
+      <SubType>UserControl</SubType>
+    </Compile>
+    <Compile Include="Path Views\DirectoryValueView.Designer.cs">
+      <DependentUpon>DirectoryValueView.cs</DependentUpon>
+    </Compile>
+    <Compile Include="Path Views\FileValueView.cs">
+      <SubType>UserControl</SubType>
+    </Compile>
+    <Compile Include="Path Views\FileValueView.Designer.cs">
+      <DependentUpon>FileValueView.cs</DependentUpon>
+    </Compile>
+    <Compile Include="Path Views\TextFileView.cs">
+      <SubType>UserControl</SubType>
+    </Compile>
+    <Compile Include="Path Views\TextFileView.Designer.cs">
+      <DependentUpon>TextFileView.cs</DependentUpon>
+    </Compile>
     <Compile Include="Plugin.cs" />
     <Compile Include="StringConvertibleMatrixColumnVisibilityDialog.cs">
@@ -196,4 +214,9 @@
   </ItemGroup>
   <ItemGroup>
+    <ProjectReference Include="..\..\HeuristicLab.Common.Resources\3.3\HeuristicLab.Common.Resources-3.3.csproj">
+      <Project>{0e27a536-1c4a-4624-a65e-dc4f4f23e3e1}</Project>
+      <Name>HeuristicLab.Common.Resources-3.3</Name>
+      <Private>False</Private>
+    </ProjectReference>
     <ProjectReference Include="..\..\HeuristicLab.Common\3.3\HeuristicLab.Common-3.3.csproj">
       <Project>{A9AD58B9-3EF9-4CC1-97E5-8D909039FF5C}</Project>
Index: /trunk/sources/HeuristicLab.Data.Views/3.3/Path Views/DirectoryValueView.Designer.cs
===================================================================
--- /trunk/sources/HeuristicLab.Data.Views/3.3/Path Views/DirectoryValueView.Designer.cs	(revision 9714)
+++ /trunk/sources/HeuristicLab.Data.Views/3.3/Path Views/DirectoryValueView.Designer.cs	(revision 9714)
@@ -0,0 +1,113 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2013 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+namespace HeuristicLab.Data.Views {
+  partial class DirectoryValueView {
+    /// <summary> 
+    /// Required designer variable.
+    /// </summary>
+    private System.ComponentModel.IContainer components = null;
+
+    /// <summary> 
+    /// Clean up any resources being used.
+    /// </summary>
+    /// <param name="disposing">true if managed resources should be disposed; otherwise, false.</param>
+    protected override void Dispose(bool disposing) {
+      if (disposing && (components != null)) {
+        components.Dispose();
+      }
+      base.Dispose(disposing);
+    }
+
+    #region Component Designer generated code
+
+    /// <summary> 
+    /// Required method for Designer support - do not modify 
+    /// the contents of this method with the code editor.
+    /// </summary>
+    private void InitializeComponent() {
+      System.ComponentModel.ComponentResourceManager resources = new System.ComponentModel.ComponentResourceManager(typeof(DirectoryValueView));
+      this.openButton = new System.Windows.Forms.Button();
+      this.folderBrowserDialog = new System.Windows.Forms.FolderBrowserDialog();
+      ((System.ComponentModel.ISupportInitialize)(this.errorProvider)).BeginInit();
+      ((System.ComponentModel.ISupportInitialize)(this.splitContainer)).BeginInit();
+      this.splitContainer.Panel1.SuspendLayout();
+      this.splitContainer.Panel2.SuspendLayout();
+      this.splitContainer.SuspendLayout();
+      this.SuspendLayout();
+      // 
+      // valueTextBox
+      // 
+      this.errorProvider.SetIconAlignment(this.valueTextBox, System.Windows.Forms.ErrorIconAlignment.MiddleLeft);
+      this.errorProvider.SetIconPadding(this.valueTextBox, 2);
+      this.valueTextBox.Location = new System.Drawing.Point(17, 2);
+      this.valueTextBox.Size = new System.Drawing.Size(87, 20);
+      // 
+      // valueLabel
+      // 
+      this.valueLabel.Location = new System.Drawing.Point(3, 5);
+      this.valueLabel.Size = new System.Drawing.Size(52, 13);
+      this.valueLabel.Text = "Directory:";
+      // 
+      // splitContainer
+      // 
+      // 
+      // splitContainer.Panel2
+      // 
+      this.splitContainer.Panel2.Controls.Add(this.openButton);
+      this.splitContainer.Size = new System.Drawing.Size(194, 24);
+      this.splitContainer.SplitterDistance = 56;
+      // 
+      // openButton
+      // 
+      this.openButton.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
+      this.openButton.Image = HeuristicLab.Common.Resources.VSImageLibrary.Open;
+      this.openButton.Location = new System.Drawing.Point(110, 0);
+      this.openButton.Name = "openButton";
+      this.openButton.Size = new System.Drawing.Size(24, 24);
+      this.openButton.TabIndex = 3;
+      this.openButton.UseVisualStyleBackColor = true;
+      this.openButton.Click += new System.EventHandler(this.openButton_Click);
+      // 
+      // DirectoryValueView
+      // 
+      this.AutoScaleDimensions = new System.Drawing.SizeF(6F, 13F);
+      this.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Font;
+      this.Name = "DirectoryValueView";
+      this.Size = new System.Drawing.Size(194, 24);
+      ((System.ComponentModel.ISupportInitialize)(this.errorProvider)).EndInit();
+      this.splitContainer.Panel1.ResumeLayout(false);
+      this.splitContainer.Panel1.PerformLayout();
+      this.splitContainer.Panel2.ResumeLayout(false);
+      this.splitContainer.Panel2.PerformLayout();
+      ((System.ComponentModel.ISupportInitialize)(this.splitContainer)).EndInit();
+      this.splitContainer.ResumeLayout(false);
+      this.ResumeLayout(false);
+
+    }
+
+    #endregion
+
+    protected System.Windows.Forms.Button openButton;
+    protected System.Windows.Forms.FolderBrowserDialog folderBrowserDialog;
+
+  }
+}
Index: /trunk/sources/HeuristicLab.Data.Views/3.3/Path Views/DirectoryValueView.cs
===================================================================
--- /trunk/sources/HeuristicLab.Data.Views/3.3/Path Views/DirectoryValueView.cs	(revision 9714)
+++ /trunk/sources/HeuristicLab.Data.Views/3.3/Path Views/DirectoryValueView.cs	(revision 9714)
@@ -0,0 +1,70 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2013 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Windows.Forms;
+using HeuristicLab.MainForm;
+
+namespace HeuristicLab.Data.Views {
+  [View("DirectoryValueView")]
+  [Content(typeof(DirectoryValue), true)]
+  public partial class DirectoryValueView : StringConvertibleValueView {
+    public new DirectoryValue Content {
+      get { return (DirectoryValue)base.Content; }
+      set { base.Content = value; }
+    }
+
+    public override bool ReadOnly {
+      get {
+        if ((Content != null) && Content.ReadOnly) return true;
+        return base.ReadOnly;
+      }
+      set { base.ReadOnly = value; }
+    }
+
+    public DirectoryValueView() {
+      InitializeComponent();
+    }
+
+    protected override void SetEnabledStateOfControls() {
+      base.SetEnabledStateOfControls();
+      valueTextBox.Enabled = !Locked && !ReadOnly && Content != null;
+      valueTextBox.ReadOnly = Locked || ReadOnly || Content == null;
+      openButton.Enabled = !Locked && !ReadOnly && Content != null;
+    }
+
+    protected override void OnContentChanged() {
+      base.OnContentChanged();
+      if (Content == null) {
+        valueTextBox.Text = string.Empty;
+        return;
+      }
+
+      valueTextBox.Text = Content.Value;
+      openButton.Enabled = !Content.ReadOnly;
+    }
+
+    protected virtual void openButton_Click(object sender, EventArgs e) {
+      if (folderBrowserDialog.ShowDialog(this) != DialogResult.OK) return;
+      Content.Value = folderBrowserDialog.SelectedPath;
+    }
+  }
+}
Index: /trunk/sources/HeuristicLab.Data.Views/3.3/Path Views/FileValueView.Designer.cs
===================================================================
--- /trunk/sources/HeuristicLab.Data.Views/3.3/Path Views/FileValueView.Designer.cs	(revision 9714)
+++ /trunk/sources/HeuristicLab.Data.Views/3.3/Path Views/FileValueView.Designer.cs	(revision 9714)
@@ -0,0 +1,112 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2013 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+namespace HeuristicLab.Data.Views {
+  partial class FileValueView {
+    /// <summary> 
+    /// Required designer variable.
+    /// </summary>
+    private System.ComponentModel.IContainer components = null;
+
+    /// <summary> 
+    /// Clean up any resources being used.
+    /// </summary>
+    /// <param name="disposing">true if managed resources should be disposed; otherwise, false.</param>
+    protected override void Dispose(bool disposing) {
+      if (disposing && (components != null)) {
+        components.Dispose();
+      }
+      base.Dispose(disposing);
+    }
+
+    #region Component Designer generated code
+
+    /// <summary> 
+    /// Required method for Designer support - do not modify 
+    /// the contents of this method with the code editor.
+    /// </summary>
+    private void InitializeComponent() {
+      System.ComponentModel.ComponentResourceManager resources = new System.ComponentModel.ComponentResourceManager(typeof(FileValueView));
+      this.openButton = new System.Windows.Forms.Button();
+      this.openFileDialog = new System.Windows.Forms.OpenFileDialog();
+      ((System.ComponentModel.ISupportInitialize)(this.errorProvider)).BeginInit();
+      ((System.ComponentModel.ISupportInitialize)(this.splitContainer)).BeginInit();
+      this.splitContainer.Panel1.SuspendLayout();
+      this.splitContainer.Panel2.SuspendLayout();
+      this.splitContainer.SuspendLayout();
+      this.SuspendLayout();
+      // 
+      // valueTextBox
+      // 
+      this.errorProvider.SetIconAlignment(this.valueTextBox, System.Windows.Forms.ErrorIconAlignment.MiddleLeft);
+      this.errorProvider.SetIconPadding(this.valueTextBox, 2);
+      this.valueTextBox.Location = new System.Drawing.Point(17, 2);
+      this.valueTextBox.Size = new System.Drawing.Size(116, 20);
+      // 
+      // valueLabel
+      // 
+      this.valueLabel.Location = new System.Drawing.Point(3, 5);
+      this.valueLabel.Size = new System.Drawing.Size(26, 13);
+      this.valueLabel.Text = "File:";
+      // 
+      // splitContainer
+      // 
+      // 
+      // splitContainer.Panel2
+      // 
+      this.splitContainer.Panel2.Controls.Add(this.openButton);
+      this.splitContainer.Size = new System.Drawing.Size(194, 24);
+      this.splitContainer.SplitterDistance = 27;
+      // 
+      // openButton
+      // 
+      this.openButton.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
+      this.openButton.Image = HeuristicLab.Common.Resources.VSImageLibrary.Open;
+      this.openButton.Location = new System.Drawing.Point(139, 0);
+      this.openButton.Name = "openButton";
+      this.openButton.Size = new System.Drawing.Size(24, 24);
+      this.openButton.TabIndex = 3;
+      this.openButton.UseVisualStyleBackColor = true;
+      this.openButton.Click += new System.EventHandler(this.openButton_Click);
+      // 
+      // FileValueView
+      // 
+      this.AutoScaleDimensions = new System.Drawing.SizeF(6F, 13F);
+      this.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Font;
+      this.Name = "FileValueView";
+      this.Size = new System.Drawing.Size(194, 24);
+      ((System.ComponentModel.ISupportInitialize)(this.errorProvider)).EndInit();
+      this.splitContainer.Panel1.ResumeLayout(false);
+      this.splitContainer.Panel1.PerformLayout();
+      this.splitContainer.Panel2.ResumeLayout(false);
+      this.splitContainer.Panel2.PerformLayout();
+      ((System.ComponentModel.ISupportInitialize)(this.splitContainer)).EndInit();
+      this.splitContainer.ResumeLayout(false);
+      this.ResumeLayout(false);
+
+    }
+
+    #endregion
+
+    protected System.Windows.Forms.Button openButton;
+    protected System.Windows.Forms.OpenFileDialog openFileDialog;
+  }
+}
Index: /trunk/sources/HeuristicLab.Data.Views/3.3/Path Views/FileValueView.cs
===================================================================
--- /trunk/sources/HeuristicLab.Data.Views/3.3/Path Views/FileValueView.cs	(revision 9714)
+++ /trunk/sources/HeuristicLab.Data.Views/3.3/Path Views/FileValueView.cs	(revision 9714)
@@ -0,0 +1,83 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2013 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Windows.Forms;
+using HeuristicLab.MainForm;
+
+namespace HeuristicLab.Data.Views {
+  [View("FileValueView")]
+  [Content(typeof(FileValue), true)]
+  public partial class FileValueView : StringConvertibleValueView {
+    public new FileValue Content {
+      get { return (FileValue)base.Content; }
+      set { base.Content = value; }
+    }
+
+    public override bool ReadOnly {
+      get {
+        if ((Content != null) && Content.ReadOnly) return true;
+        return base.ReadOnly;
+      }
+      set { base.ReadOnly = value; }
+    }
+
+    public FileValueView() {
+      InitializeComponent();
+    }
+
+    protected override void RegisterContentEvents() {
+      base.RegisterContentEvents();
+      Content.FileOpenDialogFilterChanged += new EventHandler(Content_FileOpenDialogFilterChanged);
+    }
+    protected override void DeregisterContentEvents() {
+      Content.FileOpenDialogFilterChanged -= new EventHandler(Content_FileOpenDialogFilterChanged);
+      base.DeregisterContentEvents();
+    }
+    protected override void SetEnabledStateOfControls() {
+      base.SetEnabledStateOfControls();
+      valueTextBox.Enabled = !Locked && !ReadOnly && Content != null;
+      valueTextBox.ReadOnly = Locked || ReadOnly || Content == null;
+      openButton.Enabled = !Locked && !ReadOnly && Content != null;
+    }
+
+    protected override void OnContentChanged() {
+      base.OnContentChanged();
+      if (Content == null) {
+        valueTextBox.Text = string.Empty;
+        return;
+      }
+
+      valueTextBox.Text = Content.Value;
+      openButton.Enabled = !Content.ReadOnly;
+      openFileDialog.Filter = Content.FileDialogFilter;
+    }
+
+    protected virtual void Content_FileOpenDialogFilterChanged(object sender, EventArgs e) {
+      openFileDialog.Filter = Content.FileDialogFilter;
+    }
+
+    protected virtual void openButton_Click(object sender, EventArgs e) {
+      if (openFileDialog.ShowDialog(this) != DialogResult.OK) return;
+      Content.Value = openFileDialog.FileName;
+    }
+  }
+}
Index: /trunk/sources/HeuristicLab.Data.Views/3.3/Path Views/TextFileView.Designer.cs
===================================================================
--- /trunk/sources/HeuristicLab.Data.Views/3.3/Path Views/TextFileView.Designer.cs	(revision 9714)
+++ /trunk/sources/HeuristicLab.Data.Views/3.3/Path Views/TextFileView.Designer.cs	(revision 9714)
@@ -0,0 +1,130 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2013 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+
+namespace HeuristicLab.Data.Views {
+  partial class TextFileView {
+    /// <summary> 
+    /// Required designer variable.
+    /// </summary>
+    private System.ComponentModel.IContainer components = null;
+
+    /// <summary> 
+    /// Clean up any resources being used.
+    /// </summary>
+    /// <param name="disposing">true if managed resources should be disposed; otherwise, false.</param>
+    protected override void Dispose(bool disposing) {
+      if (disposing && (components != null)) {
+        components.Dispose();
+      }
+      base.Dispose(disposing);
+    }
+
+    #region Component Designer generated code
+
+    /// <summary> 
+    /// Required method for Designer support - do not modify 
+    /// the contents of this method with the code editor.
+    /// </summary>
+    private void InitializeComponent() {
+      System.ComponentModel.ComponentResourceManager resources = new System.ComponentModel.ComponentResourceManager(typeof(TextFileView));
+      this.saveButton = new System.Windows.Forms.Button();
+      this.saveFileDialog = new System.Windows.Forms.SaveFileDialog();
+      this.fileSystemWatcher = new System.IO.FileSystemWatcher();
+      this.fileValueView = new HeuristicLab.Data.Views.FileValueView();
+      this.textBox = new System.Windows.Forms.TextBox();
+      ((System.ComponentModel.ISupportInitialize)(this.fileSystemWatcher)).BeginInit();
+      this.SuspendLayout();
+      // 
+      // saveButton
+      // 
+      this.saveButton.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
+      this.saveButton.CausesValidation = false;
+      this.saveButton.Image = HeuristicLab.Common.Resources.VSImageLibrary.Save;
+      this.saveButton.Location = new System.Drawing.Point(394, 3);
+      this.saveButton.Name = "saveButton";
+      this.saveButton.Size = new System.Drawing.Size(24, 24);
+      this.saveButton.TabIndex = 2;
+      this.saveButton.UseVisualStyleBackColor = true;
+      this.saveButton.Click += new System.EventHandler(this.saveButton_Click);
+      // 
+      // fileSystemWatcher
+      // 
+      this.fileSystemWatcher.EnableRaisingEvents = false;
+      this.fileSystemWatcher.NotifyFilter = System.IO.NotifyFilters.LastWrite | System.IO.NotifyFilters.FileName;
+      this.fileSystemWatcher.SynchronizingObject = this;
+      this.fileSystemWatcher.Changed += new System.IO.FileSystemEventHandler(this.fileSystemWatcher_Changed);
+      this.fileSystemWatcher.Created += new System.IO.FileSystemEventHandler(this.fileSystemWatcher_Changed);
+      this.fileSystemWatcher.Deleted += new System.IO.FileSystemEventHandler(this.fileSystemWatcher_Changed);
+      this.fileSystemWatcher.Renamed += new System.IO.RenamedEventHandler(this.fileSystemWatcher_Renamed);
+      // 
+      // fileValueView
+      // 
+      this.fileValueView.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left)
+            | System.Windows.Forms.AnchorStyles.Right)));
+      this.fileValueView.Caption = "FileValueView";
+      this.fileValueView.Content = null;
+      this.fileValueView.LabelVisible = true;
+      this.fileValueView.Location = new System.Drawing.Point(4, 3);
+      this.fileValueView.Name = "fileValueView";
+      this.fileValueView.ReadOnly = false;
+      this.fileValueView.Size = new System.Drawing.Size(389, 24);
+      this.fileValueView.TabIndex = 3;
+      // 
+      // textBox
+      // 
+      this.textBox.AcceptsReturn = true;
+      this.textBox.AcceptsTab = true;
+      this.textBox.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom)
+            | System.Windows.Forms.AnchorStyles.Left)
+            | System.Windows.Forms.AnchorStyles.Right)));
+      this.textBox.Font = new System.Drawing.Font("Courier New", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
+      this.textBox.Location = new System.Drawing.Point(3, 35);
+      this.textBox.Multiline = true;
+      this.textBox.Name = "textBox";
+      this.textBox.ScrollBars = System.Windows.Forms.ScrollBars.Both;
+      this.textBox.Size = new System.Drawing.Size(415, 363);
+      this.textBox.TabIndex = 4;
+      this.textBox.TextChanged += new System.EventHandler(this.textBox_TextChanged);
+      this.textBox.Validated += new System.EventHandler(this.textBox_Validated);
+      // 
+      // TextFileView
+      // 
+      this.Controls.Add(this.textBox);
+      this.Controls.Add(this.fileValueView);
+      this.Controls.Add(this.saveButton);
+      this.Name = "TextFileView";
+      this.Size = new System.Drawing.Size(421, 401);
+      ((System.ComponentModel.ISupportInitialize)(this.fileSystemWatcher)).EndInit();
+      this.ResumeLayout(false);
+      this.PerformLayout();
+
+    }
+
+    #endregion
+
+    private System.Windows.Forms.Button saveButton;
+    private System.Windows.Forms.SaveFileDialog saveFileDialog;
+    private System.IO.FileSystemWatcher fileSystemWatcher;
+    private FileValueView fileValueView;
+    private System.Windows.Forms.TextBox textBox;
+  }
+}
Index: /trunk/sources/HeuristicLab.Data.Views/3.3/Path Views/TextFileView.cs
===================================================================
--- /trunk/sources/HeuristicLab.Data.Views/3.3/Path Views/TextFileView.cs	(revision 9714)
+++ /trunk/sources/HeuristicLab.Data.Views/3.3/Path Views/TextFileView.cs	(revision 9714)
@@ -0,0 +1,247 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2013 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Drawing;
+using System.IO;
+using System.Windows.Forms;
+using HeuristicLab.Core.Views;
+using HeuristicLab.MainForm;
+
+namespace HeuristicLab.Data.Views {
+  [View("TextFileView")]
+  [Content(typeof(TextFileValue), true)]
+  public sealed partial class TextFileView : ItemView {
+    private bool changedFileContent;
+    private bool ChangedFileContent {
+      get { return changedFileContent; }
+      set {
+        if (changedFileContent != value) {
+          changedFileContent = value;
+          OnChangedFileContent();
+        }
+      }
+    }
+
+    public new TextFileValue Content {
+      get { return (TextFileValue)base.Content; }
+      set { base.Content = value; }
+    }
+
+    public TextFileView() {
+      InitializeComponent();
+      changedFileContent = false;
+    }
+
+    protected override void RegisterContentEvents() {
+      base.RegisterContentEvents();
+      Content.ValueChanged += Content_FilePathChanged;
+      Content.FileOpenDialogFilterChanged += Content_FileDialogFilterChanged;
+    }
+    protected override void DeregisterContentEvents() {
+      Content.ValueChanged -= Content_FilePathChanged;
+      Content.FileOpenDialogFilterChanged -= Content_FileDialogFilterChanged;
+      fileSystemWatcher.EnableRaisingEvents = false;
+      base.DeregisterContentEvents();
+    }
+    protected override void SetEnabledStateOfControls() {
+      base.SetEnabledStateOfControls();
+      textBox.ReadOnly = Locked || ReadOnly || Content == null;
+      saveButton.Enabled = !Locked && !ReadOnly && Content != null && ChangedFileContent;
+
+      if (Content != null && Content.Exists()) {
+        fileSystemWatcher.Filter = Path.GetFileName(Content.Value);
+        fileSystemWatcher.Path = Path.GetDirectoryName(Content.Value);
+      }
+      fileSystemWatcher.EnableRaisingEvents = Content != null && File.Exists(Content.Value) && Visible;
+    }
+
+    protected override void OnVisibleChanged(EventArgs e) {
+      //mkommend: necessary to update the textbox to detect intermediate file changes.
+      if (Visible && Content != null) UpdateTextBox();
+      base.OnVisibleChanged(e);
+    }
+
+    protected override void OnContentChanged() {
+      base.OnContentChanged();
+      ChangedFileContent = false;
+      if (Content == null) {
+        fileValueView.Content = null;
+        textBox.Text = string.Empty;
+        //mkommend: other properties of the file system watcher cannot be cleared (e.g., path) as this leads to an ArgumentException
+        fileSystemWatcher.EnableRaisingEvents = false;
+        return;
+      }
+
+      fileValueView.Content = Content;
+      saveFileDialog.Filter = Content.FileDialogFilter;
+      UpdateTextBox();
+    }
+
+    private void Content_FilePathChanged(object sender, EventArgs e) {
+      UpdateTextBox();
+      SetEnabledStateOfControls();
+    }
+    private void Content_FileDialogFilterChanged(object sender, EventArgs e) {
+      saveFileDialog.Filter = Content.FileDialogFilter;
+    }
+
+    private void textBox_TextChanged(object sender, EventArgs e) {
+      ChangedFileContent = fileText != textBox.Text;
+    }
+
+    private void OnChangedFileContent() {
+      SetEnabledStateOfControls();
+      if (ChangedFileContent) {
+        textBox.ForeColor = Color.Red;
+      } else {
+        textBox.ForeColor = Color.Black;
+      }
+    }
+
+    private bool fileSystemWatcherChangedFired = false;
+    private void fileSystemWatcher_Changed(object sender, FileSystemEventArgs e) {
+      //mkommend: cannot react on visible changed, because this event is not fired when the parent control gets visible set to false
+      if (!Visible) return;
+      //FileSystemWatcher may fire multiple events depending on how file changes are implemented in the modifying program
+      //see: http://stackoverflow.com/questions/1764809/filesystemwatcher-changed-event-is-raised-twice
+      if (fileSystemWatcherChangedFired) return;
+      fileSystemWatcherChangedFired = true;
+
+      string newContent = ReadFile(Content.Value);
+      if (newContent == textBox.Text) {
+        fileSystemWatcherChangedFired = false;
+        return;
+      }
+
+      //File created
+      if (e.ChangeType == WatcherChangeTypes.Created) {
+        UpdateTextBox();
+      }
+
+      //File changed
+      else if (e.ChangeType == WatcherChangeTypes.Changed) {
+        string msg = string.Format("The content of the file \"{0}\" has changed.\nDo you want to reload the file?", Content.Value);
+        var result = MessageBox.Show(this, msg, "Reload the file?", MessageBoxButtons.YesNo, MessageBoxIcon.Information);
+        if (result == DialogResult.Yes) {
+          UpdateTextBox();
+        } else {
+          fileText = newContent;
+          ChangedFileContent = true;
+        }
+      }
+
+      //File deleted
+      else if (e.ChangeType == WatcherChangeTypes.Deleted) {
+        string msg = string.Format("The file \"{0}\" is not present anymore. Do you want to restore the file from the given content?", Content.Value);
+        var result = MessageBox.Show(this, msg, "Restore file?", MessageBoxButtons.YesNo, MessageBoxIcon.Warning);
+        if (result == DialogResult.Yes) {
+          SaveFile();
+        }
+        UpdateTextBox();
+      }
+      fileSystemWatcherChangedFired = false;
+    }
+
+    private void fileSystemWatcher_Renamed(object sender, RenamedEventArgs e) {
+      //mkommend: cannot react on visible changed, because this event is not fired when the parent control gets visible set to false
+      if (!Visible) return;
+      string msg = string.Format("The file \"{0}\" got renamed to \"{1}\". Do you want to update the file path?", e.OldName, e.Name);
+      var result = MessageBox.Show(this, msg, "Update file path?", MessageBoxButtons.YesNo, MessageBoxIcon.Information);
+      if (result == DialogResult.Yes) {
+        Content.Value = e.FullPath;
+        fileSystemWatcher.Filter = e.Name;
+      }
+      UpdateTextBox();
+    }
+
+    private void SaveFile() {
+      //omit circular events by changing the file from HL
+      fileSystemWatcher.EnableRaisingEvents = false;
+      string path = Content.Value;
+      if (string.IsNullOrEmpty(path)) {
+        if (saveFileDialog.ShowDialog(this) != DialogResult.OK) return;
+        path = saveFileDialog.FileName;
+      }
+
+      WriteFile(path, textBox.Text);
+      Content.Value = path;
+      ChangedFileContent = false;
+      fileSystemWatcher.EnableRaisingEvents = true;
+    }
+
+    private void saveButton_Click(object sender, EventArgs e) {
+      SaveFile();
+    }
+
+    private string fileText;
+    private void UpdateTextBox() {
+      if (string.IsNullOrEmpty(Content.Value)) {
+        textBox.Enabled = false;
+        textBox.Text = string.Format("No file path is specified.");
+        return;
+      }
+
+      fileText = ReadFile(Content.Value);
+      if (fileText == null) {
+        textBox.Enabled = false;
+        textBox.Text = string.Format("The specified file \"{0}\" cannot be found.", Content.Value);
+        return;
+      }
+
+      textBox.Enabled = true;
+      textBox.Text = fileText;
+    }
+    private void textBox_Validated(object sender, EventArgs e) {
+      if (!ChangedFileContent) return;
+      string msg = string.Format("You have not saved the changes in the file \"{0}\" yet. Do you want to save the changes?", Content.Value);
+      var result = MessageBox.Show(this, msg, "Save changes?", MessageBoxButtons.YesNo, MessageBoxIcon.Information);
+      if (result == DialogResult.Yes) SaveFile();
+    }
+
+    protected override bool ProcessCmdKey(ref Message msg, Keys keyData) {
+      if (keyData == (Keys.Control | Keys.S)) {
+        SaveFile();
+        return true;
+      }
+      return base.ProcessCmdKey(ref msg, keyData);
+    }
+
+    private static string ReadFile(string path) {
+      if (!File.Exists(path)) return null;
+      string fileContent = string.Empty;
+      using (FileStream fileStream = new FileStream(path, FileMode.Open, FileAccess.Read, FileShare.Read)) {
+        using (StreamReader streamReader = new StreamReader(fileStream)) {
+          fileContent = streamReader.ReadToEnd();
+        }
+      }
+      return fileContent;
+    }
+
+    private static void WriteFile(string path, string fileContent) {
+      using (FileStream fileStream = new FileStream(path, FileMode.Create, FileAccess.Write, FileShare.Write)) {
+        using (StreamWriter streamWriter = new StreamWriter(fileStream)) {
+          streamWriter.Write(fileContent);
+        }
+      }
+    }
+  }
+}
Index: /trunk/sources/HeuristicLab.Data.Views/3.3/Plugin.cs.frame
===================================================================
--- /trunk/sources/HeuristicLab.Data.Views/3.3/Plugin.cs.frame	(revision 9713)
+++ /trunk/sources/HeuristicLab.Data.Views/3.3/Plugin.cs.frame	(revision 9714)
@@ -32,4 +32,5 @@
   [PluginFile("HeuristicLab.Data.Views-3.3.dll", PluginFileType.Assembly)]
   [PluginDependency("HeuristicLab.Common", "3.3")]
+  [PluginDependency("HeuristicLab.Common.Resources", "3.3")]
   [PluginDependency("HeuristicLab.Core", "3.3")]
   [PluginDependency("HeuristicLab.Core.Views", "3.3")]
Index: /trunk/sources/HeuristicLab.Data.Views/3.3/StringConvertibleArrayView.cs
===================================================================
--- /trunk/sources/HeuristicLab.Data.Views/3.3/StringConvertibleArrayView.cs	(revision 9713)
+++ /trunk/sources/HeuristicLab.Data.Views/3.3/StringConvertibleArrayView.cs	(revision 9714)
@@ -125,4 +125,7 @@
         Invoke(new EventHandler<EventArgs<int>>(Content_ItemChanged), sender, e);
       else {
+        // if a resize of the array occurs and some other class handles the event and provides default values
+        //then the itemChanged will occur before the reset event. hence the check was added
+        if (dataGridView.RowCount <= e.Value) return;
         dataGridView.Rows[e.Value].Cells[0].Value = Content.GetValue(e.Value);
         Size size = dataGridView.Rows[e.Value].Cells[0].PreferredSize;
Index: /trunk/sources/HeuristicLab.Data/3.3/HeuristicLab.Data-3.3.csproj
===================================================================
--- /trunk/sources/HeuristicLab.Data/3.3/HeuristicLab.Data-3.3.csproj	(revision 9713)
+++ /trunk/sources/HeuristicLab.Data/3.3/HeuristicLab.Data-3.3.csproj	(revision 9714)
@@ -117,4 +117,8 @@
     <Compile Include="Comparison.cs" />
     <Compile Include="ComparisonType.cs" />
+    <Compile Include="Path Types\DirectoryValue.cs" />
+    <Compile Include="Path Types\FileValue.cs" />
+    <Compile Include="Path Types\PathValue.cs" />
+    <Compile Include="Path Types\TextFileValue.cs" />
     <Compile Include="PercentMatrix.cs" />
     <Compile Include="PercentArray.cs" />
@@ -212,5 +216,5 @@
   -->
   <PropertyGroup>
-   <PreBuildEvent Condition=" '$(OS)' == 'Windows_NT' ">set Path=%25Path%25;$(ProjectDir);$(SolutionDir)
+    <PreBuildEvent Condition=" '$(OS)' == 'Windows_NT' ">set Path=%25Path%25;$(ProjectDir);$(SolutionDir)
 set ProjectDir=$(ProjectDir)
 set SolutionDir=$(SolutionDir)
@@ -219,5 +223,5 @@
 call PreBuildEvent.cmd
 </PreBuildEvent>
-<PreBuildEvent Condition=" '$(OS)' != 'Windows_NT' ">
+    <PreBuildEvent Condition=" '$(OS)' != 'Windows_NT' ">
 export ProjectDir=$(ProjectDir)
 export SolutionDir=$(SolutionDir)
Index: /trunk/sources/HeuristicLab.Data/3.3/Path Types/DirectoryValue.cs
===================================================================
--- /trunk/sources/HeuristicLab.Data/3.3/Path Types/DirectoryValue.cs	(revision 9714)
+++ /trunk/sources/HeuristicLab.Data/3.3/Path Types/DirectoryValue.cs	(revision 9714)
@@ -0,0 +1,44 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2013 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System.IO;
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
+namespace HeuristicLab.Data {
+  [Item("DirectoryValue", "Represents the path to a directory.")]
+  [StorableClass]
+  public class DirectoryValue : PathValue {
+    [StorableConstructor]
+    protected DirectoryValue(bool deserializing) : base(deserializing) { }
+    protected DirectoryValue(DirectoryValue original, Cloner cloner) : base(original, cloner) { }
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new DirectoryValue(this, cloner);
+    }
+
+    public DirectoryValue() : base() { }
+
+    public override bool Exists() {
+      return Directory.Exists(value);
+    }
+  }
+}
Index: /trunk/sources/HeuristicLab.Data/3.3/Path Types/FileValue.cs
===================================================================
--- /trunk/sources/HeuristicLab.Data/3.3/Path Types/FileValue.cs	(revision 9714)
+++ /trunk/sources/HeuristicLab.Data/3.3/Path Types/FileValue.cs	(revision 9714)
@@ -0,0 +1,70 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2013 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.IO;
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
+namespace HeuristicLab.Data {
+  [Item("FileValue", "Represents the path to a file.")]
+  [StorableClass]
+  public class FileValue : PathValue {
+    [Storable]
+    private string fileDialogFilter;
+    public string FileDialogFilter {
+      get { return fileDialogFilter; }
+      set {
+        if (fileDialogFilter != value) {
+          fileDialogFilter = value;
+          OnFileOpenDialogFilterChanged();
+        }
+      }
+    }
+
+    [StorableConstructor]
+    protected FileValue(bool deserializing) : base(deserializing) { }
+    protected FileValue(FileValue original, Cloner cloner)
+      : base(original, cloner) {
+      fileDialogFilter = original.FileDialogFilter;
+    }
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new FileValue(this, cloner);
+    }
+
+    public FileValue()
+      : base() {
+      fileDialogFilter = @"All files|*.*";
+    }
+
+    public override bool Exists() {
+      return File.Exists(value);
+    }
+
+    public event EventHandler FileOpenDialogFilterChanged;
+    protected virtual void OnFileOpenDialogFilterChanged() {
+      var handler = FileOpenDialogFilterChanged;
+      if (handler != null)
+        handler(this, EventArgs.Empty);
+    }
+  }
+}
Index: /trunk/sources/HeuristicLab.Data/3.3/Path Types/PathValue.cs
===================================================================
--- /trunk/sources/HeuristicLab.Data/3.3/Path Types/PathValue.cs	(revision 9714)
+++ /trunk/sources/HeuristicLab.Data/3.3/Path Types/PathValue.cs	(revision 9714)
@@ -0,0 +1,50 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2013 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+
+using System.IO;
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
+namespace HeuristicLab.Data {
+  [Item("PathValue", "Represents a path.")]
+  [StorableClass]
+  public abstract class PathValue : StringValue {
+    public override string Value {
+      get { return base.Value; }
+      set {
+        if (value == null) value = string.Empty;
+        value = value.TrimEnd(Path.DirectorySeparatorChar, Path.AltDirectorySeparatorChar);
+        base.Value = value;
+      }
+    }
+
+    [StorableConstructor]
+    protected PathValue(bool deserializing) : base(deserializing) { }
+    protected PathValue(PathValue original, Cloner cloner) : base(original, cloner) { }
+
+    protected PathValue()
+      : base(string.Empty) { }
+
+    public abstract bool Exists();
+  }
+}
Index: /trunk/sources/HeuristicLab.Data/3.3/Path Types/TextFileValue.cs
===================================================================
--- /trunk/sources/HeuristicLab.Data/3.3/Path Types/TextFileValue.cs	(revision 9714)
+++ /trunk/sources/HeuristicLab.Data/3.3/Path Types/TextFileValue.cs	(revision 9714)
@@ -0,0 +1,43 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2013 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
+namespace HeuristicLab.Data {
+  [Item("TextFile", "Represents the content and path to a text file.")]
+  [StorableClass]
+  public class TextFileValue : FileValue {
+    [StorableConstructor]
+    protected TextFileValue(bool deserializing) : base(deserializing) { }
+    protected TextFileValue(TextFileValue original, Cloner cloner)
+      : base(original, cloner) {
+    }
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new TextFileValue(this, cloner);
+    }
+
+    public TextFileValue()
+      : base() {
+    }
+  }
+}
